package org.somda.reqif.ieee

import org.docx4j.TraversalUtil
import org.docx4j.finders.RangeFinder
import org.docx4j.jaxb.Context
import org.docx4j.openpackaging.packages.WordprocessingMLPackage
import org.docx4j.wml.CTBookmark
import org.docx4j.wml.JcEnumeration
import org.docx4j.wml.P
import org.docx4j.wml.Style
import org.somda.reqif.ieee.rendering.WordConstants
import org.somda.reqif.ieee.rendering.createBoolean
import java.io.File
import java.io.FileInputStream
import java.io.FileNotFoundException
import java.io.InputStream
import java.math.BigInteger


class WordTemplate {
    constructor(fileTemplatePath: File) {
        wordProcessor = FileInputStream(fileTemplatePath)
            .let { WordprocessingMLPackage.load(it) }
            ?: throw FileNotFoundException("Template file at '$fileTemplatePath' not found")
    }

    constructor(resourceTemplatePath: String) {
        wordProcessor = javaClass.getResourceAsStream(resourceTemplatePath)
            ?.let { WordprocessingMLPackage.load(it) }
            ?: throw FileNotFoundException("Template file not found. Check for '$resourceTemplatePath' in the resource folder")
    }

    val wordProcessor: WordprocessingMLPackage

    fun transform(target: File, processBookmark: (CTBookmark) -> Unit) {
        val bookmarks = ArrayList<CTBookmark>()

        addMissingCaptionStyle()
        addRequirementStyle()

        for (p in wordProcessor.mainDocumentPart.content) {
            if (p !is P) {
                continue
            }
            val rt = RangeFinder("CTBookmark", "CTMarkupRange")
            TraversalUtil(p, rt)
            bookmarks.addAll(rt.starts)
        }

        bookmarks.forEach(processBookmark)
        wordProcessor.save(target)
    }

    /*
        Adds an IEEE custom style for annex captions that is typically generated by the IEEE word template macro
        during generation of the first annex caption. However, as the macro is not run by the ieee-converter, the
        style needs to be added manually. Otherwise, the annex captions appear in an ugly format.
     */
    private fun addMissingCaptionStyle() {
        val factory = Context.getWmlObjectFactory()
        val annexCaptionStyle: Style = factory.createStyle()
        annexCaptionStyle.type = "paragraph"
        annexCaptionStyle.styleId = WordConstants.STYLE_CAPTION
        val n: Style.Name = factory.createStyleName()
        n.`val` = WordConstants.STYLE_CAPTION.toLowerCase()
        annexCaptionStyle.name = n

        val pPr = factory.createPPr()
        pPr.keepLines = createBoolean()
        pPr.suppressAutoHyphens = createBoolean()
        pPr.jc = factory.createJc()
        pPr.jc.`val` = JcEnumeration.CENTER
        pPr.spacing = factory.createPPrBaseSpacing()
        pPr.spacing.before = BigInteger.valueOf(120L)
        pPr.spacing.after = BigInteger.valueOf(120L)
        annexCaptionStyle.pPr = pPr

        val rPr = factory.createRPr()
        rPr.rFonts = factory.createRFonts()
        rPr.rFonts.ascii = "Arial"
        rPr.rFonts.hAnsi = "Arial"
        rPr.b = createBoolean()
        rPr.lang = factory.createCTLanguage()
        rPr.lang.`val` = "en-US"
        rPr.lang.eastAsia = "ja-JP"
        annexCaptionStyle.rPr = rPr

        wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style.add(annexCaptionStyle)
    }

    /*
        Adds a custom style for requirement numbers; this avoids copying the bold-style when updating references to
        requirements.
     */
    private fun addRequirementStyle() {
        val factory = Context.getWmlObjectFactory()

        //
        // Requirements paragraph style
        //

        val requirementParagraphStyle: Style = factory.createStyle()
        requirementParagraphStyle.type = "paragraph"
        requirementParagraphStyle.styleId = WordConstants.STYLE_REQUIREMENT
        requirementParagraphStyle.basedOn = Style.BasedOn()
        requirementParagraphStyle.basedOn.`val` = WordConstants.STYLE_PARAGRAPH
        val paragraphStyleName: Style.Name = factory.createStyleName()
        paragraphStyleName.`val` = WordConstants.STYLE_REQUIREMENT
        requirementParagraphStyle.name = paragraphStyleName

        val pPr = factory.createPPr()
        pPr.jc = factory.createJc()
        pPr.jc.`val` = JcEnumeration.LEFT
        requirementParagraphStyle.pPr = pPr

        val rPr = factory.createRPr()
        rPr.b = createBoolean()
        requirementParagraphStyle.rPr = rPr

        wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style.add(requirementParagraphStyle)

        //
        // Requirements list style
        //

        val requirementUnorderedListStyle: Style = factory.createStyle()
        requirementUnorderedListStyle.type = "paragraph"
        requirementUnorderedListStyle.styleId = WordConstants.STYLE_REQUIREMENT_UNORDERED_LIST
        requirementUnorderedListStyle.basedOn = Style.BasedOn()
        requirementUnorderedListStyle.basedOn.`val` = WordConstants.STYLE_UNORDERED_LIST
        val paragraphUnorderedListStyleName: Style.Name = factory.createStyleName()
        paragraphUnorderedListStyleName.`val` = WordConstants.STYLE_REQUIREMENT_UNORDERED_LIST
        requirementUnorderedListStyle.name = paragraphUnorderedListStyleName

        val unorderedListPPr = factory.createPPr()
        unorderedListPPr.jc = factory.createJc()
        unorderedListPPr.jc.`val` = JcEnumeration.LEFT
        requirementUnorderedListStyle.pPr = unorderedListPPr

        val unorderedListRPr = factory.createRPr()
        unorderedListRPr.b = createBoolean()
        requirementUnorderedListStyle.rPr = unorderedListRPr

        wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style.add(requirementUnorderedListStyle)

        for (i in 1 .. 5) {
            createRequirementOrderedListStyle(i)
        }
    }

    private fun createRequirementOrderedListStyle(level: Int) {
        val factory = Context.getWmlObjectFactory()
        val requirementOrderedListStyle: Style = factory.createStyle()

        val styleId = WordConstants.STYLE_TEMPLATE_REQUIREMENT_NUMBERED_LIST_LEVEL.format(level)
        requirementOrderedListStyle.type = "paragraph"
        requirementOrderedListStyle.styleId = styleId
        requirementOrderedListStyle.basedOn = Style.BasedOn()
        requirementOrderedListStyle.basedOn.`val` = WordConstants.STYLE_TEMPLATE_NUMBERED_LIST_LEVEL.format(level)
        val paragraphOrderedListStyleName: Style.Name = factory.createStyleName()
        paragraphOrderedListStyleName.`val` = styleId
        requirementOrderedListStyle.name = paragraphOrderedListStyleName

        val orderedListPPr = factory.createPPr()
        orderedListPPr.jc = factory.createJc()
        orderedListPPr.jc.`val` = JcEnumeration.LEFT
        requirementOrderedListStyle.pPr = orderedListPPr

        val orderedListRPr = factory.createRPr()
        orderedListRPr.b = createBoolean()
        requirementOrderedListStyle.rPr = orderedListRPr

        wordProcessor.mainDocumentPart.styleDefinitionsPart.jaxbElement.style.add(requirementOrderedListStyle)
    }
}

//<w:style w:type="paragraph" w:customStyle="1" w:styleId="RequirementsList">
//<w:name w:val="RequirementsList"/>
//<w:basedOn w:val="IEEEStdsUnorderedList"/>
//<w:link w:val="RequirementsListChar"/>
//<w:qFormat/>
//<w:rsid w:val="001606FD"/>
//<w:pPr>
//<w:jc w:val="left"/>
//</w:pPr>
//<w:rPr>
//<w:b/>
//</w:rPr>
//</w:style>